# coding: utf-8

"""
    The Selling Partner API for Amazon Seller Wallet Open Banking API

    The Selling Partner API for Seller Wallet (Seller Wallet API) provides financial information that is relevant to a seller's Seller Wallet account. You can obtain financial events, balances, and transfer schedules for Seller Wallet accounts. You can also schedule and initiate transactions.

    The version of the OpenAPI document: 2024-03-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class Fee(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'fee_id': 'str',
        'fee_type': 'FeeType',
        'fee_rate_value': 'float',
        'fee_amount': 'Currency',
    }

    attribute_map = {
        'fee_id': 'feeId',
        'fee_type': 'feeType',
        'fee_rate_value': 'feeRateValue',
        'fee_amount': 'feeAmount',
    }

    def __init__(self, fee_id=None, fee_type=None, fee_rate_value=None, fee_amount=None, _configuration=None):  # noqa: E501
        """Fee - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._fee_id = None
        self._fee_type = None
        self._fee_rate_value = None
        self._fee_amount = None
        self.discriminator = None

        self.fee_id = fee_id
        self.fee_type = fee_type
        self.fee_rate_value = fee_rate_value
        self.fee_amount = fee_amount

    @property
    def fee_id(self):
        """Gets the fee_id of this Fee.  # noqa: E501

        The unique identifier assigned to the fee.  # noqa: E501

        :return: The fee_id of this Fee.  # noqa: E501
        :rtype: str
        """
        return self._fee_id

    @fee_id.setter
    def fee_id(self, fee_id):
        """Sets the fee_id of this Fee.

        The unique identifier assigned to the fee.  # noqa: E501

        :param fee_id: The fee_id of this Fee.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and fee_id is None:
            raise ValueError("Invalid value for `fee_id`, must not be `None`")  # noqa: E501

        self._fee_id = fee_id

    @property
    def fee_type(self):
        """Gets the fee_type of this Fee.  # noqa: E501


        :return: The fee_type of this Fee.  # noqa: E501
        :rtype: FeeType
        """
        return self._fee_type

    @fee_type.setter
    def fee_type(self, fee_type):
        """Sets the fee_type of this Fee.


        :param fee_type: The fee_type of this Fee.  # noqa: E501
        :type: FeeType
        """
        if self._configuration.client_side_validation and fee_type is None:
            raise ValueError("Invalid value for `fee_type`, must not be `None`")  # noqa: E501

        self._fee_type = fee_type

    @property
    def fee_rate_value(self):
        """Gets the fee_rate_value of this Fee.  # noqa: E501

        A decimal number, such as an amount or FX rate.  # noqa: E501

        :return: The fee_rate_value of this Fee.  # noqa: E501
        :rtype: float
        """
        return self._fee_rate_value

    @fee_rate_value.setter
    def fee_rate_value(self, fee_rate_value):
        """Sets the fee_rate_value of this Fee.

        A decimal number, such as an amount or FX rate.  # noqa: E501

        :param fee_rate_value: The fee_rate_value of this Fee.  # noqa: E501
        :type: float
        """
        if self._configuration.client_side_validation and fee_rate_value is None:
            raise ValueError("Invalid value for `fee_rate_value`, must not be `None`")  # noqa: E501

        self._fee_rate_value = fee_rate_value

    @property
    def fee_amount(self):
        """Gets the fee_amount of this Fee.  # noqa: E501


        :return: The fee_amount of this Fee.  # noqa: E501
        :rtype: Currency
        """
        return self._fee_amount

    @fee_amount.setter
    def fee_amount(self, fee_amount):
        """Sets the fee_amount of this Fee.


        :param fee_amount: The fee_amount of this Fee.  # noqa: E501
        :type: Currency
        """
        if self._configuration.client_side_validation and fee_amount is None:
            raise ValueError("Invalid value for `fee_amount`, must not be `None`")  # noqa: E501

        self._fee_amount = fee_amount

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Fee, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Fee):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Fee):
            return True

        return self.to_dict() != other.to_dict()
