# coding: utf-8

"""
    The Selling Partner API for Amazon Seller Wallet Open Banking API

    The Selling Partner API for Seller Wallet (Seller Wallet API) provides financial information that is relevant to a seller's Seller Wallet account. You can obtain financial events, balances, and transfer schedules for Seller Wallet accounts. You can also schedule and initiate transactions.

    The version of the OpenAPI document: 2024-03-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class PaymentPreference(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payment_preference_payment_type': 'PaymentPreferencePaymentType',
        'value': 'float',
    }

    attribute_map = {
        'payment_preference_payment_type': 'paymentPreferencePaymentType',
        'value': 'value',
    }

    def __init__(self, payment_preference_payment_type=None, value=None, _configuration=None):  # noqa: E501
        """PaymentPreference - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._payment_preference_payment_type = None
        self._value = None
        self.discriminator = None

        self.payment_preference_payment_type = payment_preference_payment_type
        self.value = value

    @property
    def payment_preference_payment_type(self):
        """Gets the payment_preference_payment_type of this PaymentPreference.  # noqa: E501


        :return: The payment_preference_payment_type of this PaymentPreference.  # noqa: E501
        :rtype: PaymentPreferencePaymentType
        """
        return self._payment_preference_payment_type

    @payment_preference_payment_type.setter
    def payment_preference_payment_type(self, payment_preference_payment_type):
        """Sets the payment_preference_payment_type of this PaymentPreference.


        :param payment_preference_payment_type: The payment_preference_payment_type of this PaymentPreference.  # noqa: E501
        :type: PaymentPreferencePaymentType
        """
        if self._configuration.client_side_validation and payment_preference_payment_type is None:
            raise ValueError("Invalid value for `payment_preference_payment_type`, must not be `None`")  # noqa: E501

        self._payment_preference_payment_type = payment_preference_payment_type

    @property
    def value(self):
        """Gets the value of this PaymentPreference.  # noqa: E501

        A decimal number, such as an amount or FX rate.  # noqa: E501

        :return: The value of this PaymentPreference.  # noqa: E501
        :rtype: float
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this PaymentPreference.

        A decimal number, such as an amount or FX rate.  # noqa: E501

        :param value: The value of this PaymentPreference.  # noqa: E501
        :type: float
        """
        if self._configuration.client_side_validation and value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentPreference, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentPreference):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PaymentPreference):
            return True

        return self.to_dict() != other.to_dict()
