# coding: utf-8

"""
    The Selling Partner API for Amazon Seller Wallet Open Banking API

    The Selling Partner API for Seller Wallet (Seller Wallet API) provides financial information that is relevant to a seller's Seller Wallet account. You can obtain financial events, balances, and transfer schedules for Seller Wallet accounts. You can also schedule and initiate transactions.

    The version of the OpenAPI document: 2024-03-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class TransferScheduleRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'source_account_id': 'str',
        'source_currency_code': 'str',
        'destination_account_id': 'str',
        'destination_transaction_instrument': 'TransactionInstrumentDetails',
        'transaction_type': 'TransactionType',
        'transfer_schedule_information': 'TransferScheduleInformation',
        'payment_preference': 'PaymentPreference',
        'transfer_schedule_status': 'TransferScheduleStatus',
    }

    attribute_map = {
        'source_account_id': 'sourceAccountId',
        'source_currency_code': 'sourceCurrencyCode',
        'destination_account_id': 'destinationAccountId',
        'destination_transaction_instrument': 'destinationTransactionInstrument',
        'transaction_type': 'transactionType',
        'transfer_schedule_information': 'transferScheduleInformation',
        'payment_preference': 'paymentPreference',
        'transfer_schedule_status': 'transferScheduleStatus',
    }

    def __init__(self, source_account_id=None, source_currency_code=None, destination_account_id=None, destination_transaction_instrument=None, transaction_type=None, transfer_schedule_information=None, payment_preference=None, transfer_schedule_status=None, _configuration=None):  # noqa: E501
        """TransferScheduleRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._source_account_id = None
        self._source_currency_code = None
        self._destination_account_id = None
        self._destination_transaction_instrument = None
        self._transaction_type = None
        self._transfer_schedule_information = None
        self._payment_preference = None
        self._transfer_schedule_status = None
        self.discriminator = None

        self.source_account_id = source_account_id
        self.source_currency_code = source_currency_code
        self.destination_account_id = destination_account_id
        self.destination_transaction_instrument = destination_transaction_instrument
        self.transaction_type = transaction_type
        self.transfer_schedule_information = transfer_schedule_information
        self.payment_preference = payment_preference
        if transfer_schedule_status is not None:
            self.transfer_schedule_status = transfer_schedule_status

    @property
    def source_account_id(self):
        """Gets the source_account_id of this TransferScheduleRequest.  # noqa: E501

        The unique identifier of the source Amazon Seller Wallet bank account from which money is debited.  # noqa: E501

        :return: The source_account_id of this TransferScheduleRequest.  # noqa: E501
        :rtype: str
        """
        return self._source_account_id

    @source_account_id.setter
    def source_account_id(self, source_account_id):
        """Sets the source_account_id of this TransferScheduleRequest.

        The unique identifier of the source Amazon Seller Wallet bank account from which money is debited.  # noqa: E501

        :param source_account_id: The source_account_id of this TransferScheduleRequest.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and source_account_id is None:
            raise ValueError("Invalid value for `source_account_id`, must not be `None`")  # noqa: E501

        self._source_account_id = source_account_id

    @property
    def source_currency_code(self):
        """Gets the source_currency_code of this TransferScheduleRequest.  # noqa: E501

        The three-letter currency code of the source payment method country, in ISO 4217 format.  # noqa: E501

        :return: The source_currency_code of this TransferScheduleRequest.  # noqa: E501
        :rtype: str
        """
        return self._source_currency_code

    @source_currency_code.setter
    def source_currency_code(self, source_currency_code):
        """Sets the source_currency_code of this TransferScheduleRequest.

        The three-letter currency code of the source payment method country, in ISO 4217 format.  # noqa: E501

        :param source_currency_code: The source_currency_code of this TransferScheduleRequest.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and source_currency_code is None:
            raise ValueError("Invalid value for `source_currency_code`, must not be `None`")  # noqa: E501

        self._source_currency_code = source_currency_code

    @property
    def destination_account_id(self):
        """Gets the destination_account_id of this TransferScheduleRequest.  # noqa: E501

        The unique identifier of the destination bank account where the money is deposited.  # noqa: E501

        :return: The destination_account_id of this TransferScheduleRequest.  # noqa: E501
        :rtype: str
        """
        return self._destination_account_id

    @destination_account_id.setter
    def destination_account_id(self, destination_account_id):
        """Sets the destination_account_id of this TransferScheduleRequest.

        The unique identifier of the destination bank account where the money is deposited.  # noqa: E501

        :param destination_account_id: The destination_account_id of this TransferScheduleRequest.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and destination_account_id is None:
            raise ValueError("Invalid value for `destination_account_id`, must not be `None`")  # noqa: E501

        self._destination_account_id = destination_account_id

    @property
    def destination_transaction_instrument(self):
        """Gets the destination_transaction_instrument of this TransferScheduleRequest.  # noqa: E501


        :return: The destination_transaction_instrument of this TransferScheduleRequest.  # noqa: E501
        :rtype: TransactionInstrumentDetails
        """
        return self._destination_transaction_instrument

    @destination_transaction_instrument.setter
    def destination_transaction_instrument(self, destination_transaction_instrument):
        """Sets the destination_transaction_instrument of this TransferScheduleRequest.


        :param destination_transaction_instrument: The destination_transaction_instrument of this TransferScheduleRequest.  # noqa: E501
        :type: TransactionInstrumentDetails
        """
        if self._configuration.client_side_validation and destination_transaction_instrument is None:
            raise ValueError("Invalid value for `destination_transaction_instrument`, must not be `None`")  # noqa: E501

        self._destination_transaction_instrument = destination_transaction_instrument

    @property
    def transaction_type(self):
        """Gets the transaction_type of this TransferScheduleRequest.  # noqa: E501


        :return: The transaction_type of this TransferScheduleRequest.  # noqa: E501
        :rtype: TransactionType
        """
        return self._transaction_type

    @transaction_type.setter
    def transaction_type(self, transaction_type):
        """Sets the transaction_type of this TransferScheduleRequest.


        :param transaction_type: The transaction_type of this TransferScheduleRequest.  # noqa: E501
        :type: TransactionType
        """
        if self._configuration.client_side_validation and transaction_type is None:
            raise ValueError("Invalid value for `transaction_type`, must not be `None`")  # noqa: E501

        self._transaction_type = transaction_type

    @property
    def transfer_schedule_information(self):
        """Gets the transfer_schedule_information of this TransferScheduleRequest.  # noqa: E501


        :return: The transfer_schedule_information of this TransferScheduleRequest.  # noqa: E501
        :rtype: TransferScheduleInformation
        """
        return self._transfer_schedule_information

    @transfer_schedule_information.setter
    def transfer_schedule_information(self, transfer_schedule_information):
        """Sets the transfer_schedule_information of this TransferScheduleRequest.


        :param transfer_schedule_information: The transfer_schedule_information of this TransferScheduleRequest.  # noqa: E501
        :type: TransferScheduleInformation
        """
        if self._configuration.client_side_validation and transfer_schedule_information is None:
            raise ValueError("Invalid value for `transfer_schedule_information`, must not be `None`")  # noqa: E501

        self._transfer_schedule_information = transfer_schedule_information

    @property
    def payment_preference(self):
        """Gets the payment_preference of this TransferScheduleRequest.  # noqa: E501


        :return: The payment_preference of this TransferScheduleRequest.  # noqa: E501
        :rtype: PaymentPreference
        """
        return self._payment_preference

    @payment_preference.setter
    def payment_preference(self, payment_preference):
        """Sets the payment_preference of this TransferScheduleRequest.


        :param payment_preference: The payment_preference of this TransferScheduleRequest.  # noqa: E501
        :type: PaymentPreference
        """
        if self._configuration.client_side_validation and payment_preference is None:
            raise ValueError("Invalid value for `payment_preference`, must not be `None`")  # noqa: E501

        self._payment_preference = payment_preference

    @property
    def transfer_schedule_status(self):
        """Gets the transfer_schedule_status of this TransferScheduleRequest.  # noqa: E501


        :return: The transfer_schedule_status of this TransferScheduleRequest.  # noqa: E501
        :rtype: TransferScheduleStatus
        """
        return self._transfer_schedule_status

    @transfer_schedule_status.setter
    def transfer_schedule_status(self, transfer_schedule_status):
        """Sets the transfer_schedule_status of this TransferScheduleRequest.


        :param transfer_schedule_status: The transfer_schedule_status of this TransferScheduleRequest.  # noqa: E501
        :type: TransferScheduleStatus
        """

        self._transfer_schedule_status = transfer_schedule_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TransferScheduleRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TransferScheduleRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TransferScheduleRequest):
            return True

        return self.to_dict() != other.to_dict()
